<!DOCTYPE HTML>
<html xmlns:th="https://www.thymeleaf.org">
<head>
    <title>REST API docs</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
</head>
<body>
<h1>REST API docs</h1>
<p>REST API methods are found on: http://localhost:8080/api</p>
<h2>Notes</h2>
<p>Note #1: there are 2 user roles for authorization:</p>
<ul>
    <li>ROLE_USER - "ordinary" user; role which is by default given in POST /users API.</li>
    <li>ROLE_ADMIN - admin user; admin users are directly recorded in users.json file with role field set to "ROLE_ADMIN".</li>
</ul>
<p>Note #2: there are 2 collections of URLs found at /api URL.</p>
<ul>
    <li>/users - collection with URLs for CRUD operations with web service users; current state of users list is operated on users.json working file.</li>
    <li>/posts - collection with URLs for CRUD operations with the web service users' posts; current state of users' posts list is operated on posts.json working file. This is motivated by posts users publish on famous social app web platforms.</li>
</ul>
<p>--------------------------------------------</p>

<h2>createUser (POST /users)</h2>
<p>Method creates a new user.</p>
<p>AUTHENTICATION: not required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: UserModel userModel - object representation of a user to be created; following fields must be non-null: password, username, email</p>
<p>OUT: UserModel - object representation of the newly created user</p>
<p>FUNCTION: a new user with given password, username and email is created and recorded in users.json file. The user id is calculated as the ID following the maximum user ID from users in users.json. The password is encrypted using BCryptPasswordEncoder, which uses standard version of BCrypt hashing function. The user role is set to "ROLE_USER" by default (as noted in Note #1).</p>
<p>EXCEPTIONS:</p>
<ul>
    <li>ResponseStatusException : HttpStatus.BAD_REQUEST (400) if user cannot be created because not all needed data have been provided (password, username, email)</li>
    <li>ResponseStatusException : HttpStatus.CONFLICT (409) if user cannot be created because a user with the username already exists</li>
</ul>

<h2>deleteUser (DELETE /users/{id})</h2>
<p>Method deletes the user with given "id" given as the path variable.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: ROLE_ADMIN</p>
<p>IN: Long id - id of a user to be deleted</p>
<p>OUT: void</p>
<p>FUNCTION: the user with given user id is deleted from users.json file. If the user with id does not exist, nothing is done and status is OK (following idempotence rule).</p>
<p>EXCEPTIONS: -</p>

<h2>deleteUserLoggedIn (DELETE /users)</h2>
<p>Method deletes the currently logged in user.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: -</p>
<p>OUT: void</p>
<p>FUNCTION: the currently logged in user is deleted from users.json file. The deletion is done by the user's id which is found as the id corresponding to the logged in user's username. Also, all the user's posts (if any) are deleted from posts.json file.</p>
<p>EXCEPTIONS: -</p>

<h2>getUser (GET /users/{id})</h2>
<p>Method gets the user with given "id" given as the path variable.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: ROLE_ADMIN</p>
<p>IN: Long id - id of a user to be retrieved</p>
<p>OUT: UserModel - object representation of the retrieved user</p>
<p>FUNCTION: the user with given id is retrieved from users.json file.</p>
<p>EXCEPTIONS: </p>
<ul>
    <li>ResponseStatusException : HttpStatus.NOT_FOUND (404) if user with given id does not exist</li>
</ul>

<h2>getUserLoggedIn (GET /users)</h2>
<p>Method gets the currently logged in user.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: -</p>
<p>OUT: UserModel - object representation of the retrieved user</p>
<p>FUNCTION: the currently logged in user is retrieved from users.json file. The retrieval is done by the user's id which is found as the id corresponding to the logged in user's username.</p>
<p>EXCEPTIONS: -</p>

<h2>updateUser (PUT /users)</h2>
<p>Method updates the currently logged in user with data given in the request body.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: UserModel userModel - object representation of a user to be updated; at least one of the following fields must be non-null: password, username, email</p>
<p>OUT: UserModel - object representation of the updated user</p>
<p>FUNCTION: the currently logged in user is updated in users.json file. The update is done with the given input new user data by the user's id which is found as the id corresponding to the logged in user's username. The password is encrypted using BCryptPasswordEncoder i.e. in the same way as in POST /users method when a user is being created.</p>
<p>EXCEPTIONS: </p>
<ul>
    <li>ResponseStatusException : HttpStatus.BAD_REQUEST (400) if user cannot be updated because none of needed data have been provided (password, username or/and email)</li>
    <li>ResponseStatusException : HttpStatus.CONFLICT (409) if user cannot be updated because a user with the given username already exists i.e. user cannot update username to the username of any other user</li>
</ul>

<h2>createUserPost (POST /posts)</h2>
<p>Method creates a new post for the currently logged in user with data given in the request body.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: PostModel postModel - object representation of a user's post to be created; following field must be non-null and non-empty: text</p>
<p>OUT: PostModel - object representation of the newly created post</p>
<p>FUNCTION: a new post with given text is created and recorded in posts.json file. The post id is calculated as the ID following the maximum post ID from posts in posts.json. The user ID of the newly created post is set to user ID of the currently logged in user who creates this post.</p>
<p>EXCEPTIONS:</p>
<ul>
    <li>ResponseStatusException : HttpStatus.BAD_REQUEST (400) if post cannot be updated because needed data has not been provided (text)</li>
</ul>

<h2>deletePost (DELETE /posts/{id})</h2>
<p>Method deletes the post with given "id" given as the path variable.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: Long id - id of a post to be deleted</p>
<p>OUT: void</p>
<p>FUNCTION: the post with given post id is deleted from posts.json file. If the post with id does not exist, nothing is done and status is OK (following idempotence rule).</p>
<p>EXCEPTIONS:</p>
<ul>
    <li>ResponseStatusException : HttpStatus.FORBIDDEN (403) if post cannot be deleted because the logged in user tries to delete other user's post</li>
</ul>

<h2>getPost (GET /posts/{id})</h2>
<p>Method gets the post with given "id" given as the path variable.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: Long id - id of a post to be retrieved</p>
<p>OUT: PostModel - object representation of the retrieved post</p>
<p>FUNCTION: the post with given post id is retrieved from posts.json file.</p>
<p>EXCEPTIONS:</p>
<ul>
    <li>ResponseStatusException : HttpStatus.NOT_FOUND (404) if post with given id does not exist</li>
</ul>

<h2>updatePost (PUT /posts/{id})</h2>
<p>Method updates the post with given "id" given as the path variable with data given in the request body.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: Long id - id of a post to be updated, PostModel postModel - object representation of a post to be updated; following field must be non-null and non-empty: text</p>
<p>OUT: PostModel - object representation of the updated post</p>
<p>FUNCTION: the post with given post id is updated in posts.json file. The update is done with the given input new post data by the post's id and the user's id which is found as the id corresponding to the logged in user's username.</p>
<p>EXCEPTIONS:</p>
<ul>
    <li>ResponseStatusException : HttpStatus.BAD_REQUEST (400) if post cannot be updated because needed data has not been provided (text)</li>
    <li>ResponseStatusException : HttpStatus.FORBIDDEN (403) if post cannot be updated because the logged in user tries to update other user's post</li>
    <li>ResponseStatusException : HttpStatus.NOT_FOUND (404) if post with given id does not exist</li>
</ul>

<h2>getUserPosts (GET /users/{usrid}/posts)</h2>
<p>Method gets the posts from user with given "usrid" given as the path variable.</p>
<p>AUTHENTICATION: required</p>
<p>AUTHORIZATION: all roles</p>
<p>IN: Long usrid - id of a user whose posts are to be retrieved</p>
<p>OUT: JSONArray - JSON array representation of the list of the posts from user with usrid</p>
<p>FUNCTION: the posts from user with given user id (usrid) are retrieved from posts.json file. The retrieval is done with the given user's id which is used to find all the posts from the user in posts.json where userId field is set to usrid.</p>
<p>EXCEPTIONS:</p>
<ul>
    <li>ResponseStatusException : HttpStatus.NOT_FOUND (404) if user with given id does not exist</li>
</ul>


</body>
</html>